#!/bin/bash
# Extracción de elementos highway=* de Madrid de OSM
#
# Santiago Crespo 2022


# exit when any command fails
set -e

DIA=`date +%Y-%m-%d`
HORA=`date +%H-%M-%S`
DIR="$DIA-$HORA"

echo "$DIR"
mkdir "$DIR"
cd "$DIR"

echo "pbf from geofabrik"
#wget "https://download.geofabrik.de/europe/spain-latest.osm.pbf" -O spain-latest.osm.pbf
wget "https://download.geofabrik.de/europe/spain/madrid-latest.osm.pbf" -O madrid-latest.osm.pbf

mv madrid-latest.osm.pbf /var/www/html/

echo "Fake version y cortar Madrid"
wget https://cartobase.es/madrid-con-aeropuerto_0.poly -O madrid-con-aeropuerto_0.poly
osmconvert --fake-version --timestamp=NOW-1 -B="madrid-con-aeropuerto_0.poly" --complete-ways --drop-broken-refs -o=madrid-bruto.osm /var/www/html/madrid-latest.osm.pbf

echo "Añadir timestamp y version (si no, falla osmosis)"
DIA=`date +%Y-%m-%d`
HORA=`date +%H:%M:%S`
osmconvert --fake-version --fake-author --timestamp="$DIA"T"$HORA"Z madrid-bruto.osm -o=madrid-bruto-timestamp1.osm # Si no, falla por no tener timestamp
# perl -pe 's/id="/timestamp="'$DIA'T'$HORA'Z" id="-/g' madrid-bruto-timestamp1.osm | perl -pe "s/nd ref=\"/nd ref=\"-/g" > madrid-bruto-timestamp.osm
perl -pe 's/id="/timestamp="'$DIA'T'$HORA'Z" id="/g' madrid-bruto-timestamp1.osm  > madrid-bruto-timestamp.osm

echo "Extract highways and write .osm file"
osmosis --read-xml file="madrid-bruto-timestamp.osm" --way-key keyList="highway" --used-node --write-xml madrid-highways.osm

echo "filter 1"
osmfilter madrid-highways.osm --drop-relations --keep="highway= exit_to= oneway= lanes= ref= bicycle= bridge= tunnel= cycleway= crossing= mountain_pass=" --drop-tags="url= source= source:*= *:source=" > madrid-highways-prefiltrado.osm

#osmfilter --drop-relations="all" --drop-node-tags="addr:*= highway=bus_stop url= amenity= shop= old_name= entrance= name= tourism= railway= public_transport:version= public_transport= route=" madrid-highways-prefiltrado.osm > madrid-highways-prefiltrado2.osm
echo "filter 2"
# --drop-node-tags=
osmfilter --drop-node-way-tags="addr:*= highway=bus_stop highway=elevator url= amenity= shop= old_name= entrance= tourism= railway= public_transport:version= route= public_transport= fuel:*= highway=street_lamp highway=traffic_signals highway=stop highway=speed_camera highway=give_way crossing=traffic_signals" madrid-highways-prefiltrado.osm > madrid-highways-prefiltrado2.osm

echo "filter 3"
osmfilter --drop-node-way-tags="network= route= alt_name= created_by= public_transport= lit= ref:colour= building= bus= addr:housenumber= shelter= addr:street= amenity= bench= converted_by= addr:postcode= addr:city= railway= ref:colour_bg= admin_level= int_ref= entrance= is_in= is_in:country= addr:country= is_in:province= boundary= is_in:region= is_in:municipality= building:levels= population= leisure= colour= population:date= parking= uic_name= place= note= landuse= url= ine:municipio= public_transport:version= idee:name= website= route_master= ele= capital= is_in:country_code= is_in:province_code= source:file= traffic_signals= ref:ine= source:ele= shop= bicycle:source= emergency= fixme= is_in:continent= source:url= station= opening_hours= traffic_signals:sound= tourism= covered= height= phone= fare_area= local_ref= sport= addr:province= natural= man_made= source:ref= educamadrid:cod_centro= educamadrid:transporte= contact:phone= educamadrid:bilingue= educamadrid:horario_amp= educamadrid:municipio= educamadrid:tipo= educamadrid:tipo_via= educamadrid:comedor= educamadrid:publico_bilingue= educamadrid:numero_portal= educamadrid:codigo_postal= educamadrid:telefono= educamadrid:nombre_via= description= educamadrid:fax= educamadrid:url= is_in:date= train= name:ru= cuisine= addr:state= name:es= history= waterway= postal_code= addr:ward= building:part= fuel:diesel= label= fuel:octane_95= forestry= name:en= name:uk= fuel:octane_98= contact:website= fuel:GTL_diesel= roof:shape= stop_id= religion= ski= ref:url= email= FIXME= historic= enforcement= addr:subdistrict= political_division= denomination= information= brand= building:colour= office= tourist_bus= addr:housename= MAC_dec= name:ja= tram= is_in:state= is_in:state_code= name:fr= name:zh= name:pl= contact:email= educamadrid:distrito= note:es= population:source= building:color= leaf_type= wood= fare_zone= building:use= fax= roof:colour= name:ca= roof:material= building:material= capacity= name:de= name:pt= name:hu= power= addr:district= agricultural= cattle= location= name:sr= ngbe:codigo= ngbe:grupo= ngbe:hojabcn25= ngbe:huso= ngbe:id= ngbe:lat_ed50= ngbe:lon_ed50= ngbe:subgrupo= ngbe:tema= ngbe:tipotexto= ngbe:version= ngbe:xutm_ed50= ngbe:yutm_ed50= proposed= site= atm= atm:network= ref:colour_tx= source:email= subway= addr:suburb= artwork_type= map_type= noref= highway_1= name:lt= source:description= source:opening_hours= artist_name= building:facade:material= Calle= source:addr= source:phone= trees= usage= atm:operator= color= contact:fax= indoor= ISO3166-2= name:eu= playground= source:fax= source:wheelchair= contact:facebook= name:el= toilets= voltage= wikipedia:en= wikipedia:es= car= drinking_water= frequency= gauge= heritage= heritage:operator= platforms= sid= survey= building:min_level= ine:provincia= int_name= is_in:region_code= name:ar= name:ko= ref:color= social_facility= stars= water= ACCESO= ACCESO_DES= ALTA_DB= building:roof:shape= CIRCULACIO= CIRCUL_DES= COMPET_DES= COMPETENCI= crossing:light= date= DGC_VIA= ESTADOFIS= ESTFIS_DES= ID_TRAMO= ID_VIAL= INE_VIA= is_in:city= LONGITUD= maxlength= name:ast= name:it= name:lb= name:nl= NOM_ALTERN= official_name:pt= ORDEN= recycling:cans= recycling_type= roof:height= SITUAC_DES= SITUACION= softness= start_date= TIPO_V_DES= TIPO_VIA= TIP_VIA_IN= TR_FUE_DES= TR_FUENTE= V_FUENTE= V_FUENTE_D= wheelchair_toilet= border_type= cables= contact:cellphone= Fixme= grade= guidepost= ign:latitud= ign:longitud= ign:red= interval= leaf_cycle= local_name= name:bar= name:be= name:bg= name:eo= name:fi= name:he= name:is= name:ka= name:la= name:no= name:sk= name:sl= name:sv= NOM_VIA= operator= old:aeroway= ORDEN_DES= park_ride= pk= recycling:glass= recycling:paper= smoking= social_facility:for= sorting_name= state= surveillance= surveillance:type= traffic_signals:vibration= wires= aeroway= arcade:left= bin= building:max_level= camera:mount= camera:type= colonnade:right= comments= craft= electrified= ine:ccaa= information:voice= max= name:am= name:an= name:ba= name:bn= name:bo= name:botanical= name:bs= name:cs= name:cv= name:da= name:ext= name:fa= name:ga= name:haw= name:hi= name:hr= name:hy= name:kk= name:kn= name:ku= name:lv= name:mk= name:ml= name:mn= name:mr= name:nn= name:ro= name:sq= name:ta= name:tg= name:th= name:tr= name:ur= note:en= opening_hours:url= protect_class= roof:color= roof:orientation= seasonal= side= source:date:phone= source:date:url= source:population= stair= surveillance:zone= wikipedia:fr= withIndoor= wpt_description= acrrecess= amenity_1= city= colour:arrow= colour:back= colour:text= contact:google_plus= contact:mobile= continue= cro= destinanation= destination:lanes:backward= dispensing= disused= disused:highway= entry= fence_type= footot= fuel:HGV_diesel= golf:course= golf:par= highspeed= image= interchange= ISO3166-1= ISO3166-1:alpha2= ISO3166-1:alpha3= ISO3166-1:numeric= name:af= name:arc= name:arz= name:az= name:bat-smg= name:be-tarask= name:br= name:chr= name:ckb= name:co= name:cy= name:dz= name:ee= name:et= name:fo= name:fur= name:fy= name:gd= name:gu= name:gv= name:ia= name:id= name:kab= name:kbd= name:kl= name:km= name:koi= name:kv= name:ky= name:lez= name:ln= name:mg= name:mhr= name:mi= name:ms= name:mt= name:my= name:mzn= name:nds-nl= name:ne= name_old= name:or= name:os= name:pnb= name:ps= name:rm= name:rn= name:rue= name:sa= name:sah= name:scn= name:se= name:so= name:sw= name:szl= name:te= name:tet= name:tl= name:to= name:cn= name:tt= name:udm= name:vi= name:xmf= name:yi= name:yo= name:zh_pinyin= name:zh-yue= name:zu= narrow= network_1= official_name:el= official_name:es= payment:bitcoin= protection_title= recycling:batteries= recycling:clothes= recycling:scrap_metal= roof:levels= sendas= source:date:addr= species= speed= stile= swing_gate:type= terrain= toll:automatic= tower:type= traffic_sign:forward= wifi= wikipedia:de= wikipedia:pt= wikipedia:ru= alt_name:eo= architect= bicycle_parking= boat= booking= building:height= building:levels:underground= building:roof:orientation= bus_1= by_night= capacity:parent= capacity:private= capital_city= carpenter= community= community:gender= Community:gender= contact:twitter= country= country_code_fips= country_code_iso3166_1_alpha_2= crop= crossing:bell= currency= day_off= day_on= denotation= department= description:zh= destination:b= dining= drive_through= e-road:class= faculty= female= ferry= fire_hydrant:couplings= fire_hydrant:coupling_type= fire_hydrant:position= fire_hydrant:type= fixme:name= flag= fuel:diesel_B= fuel:diesel_C= fuel:lpg= gambling= government= honk= inline_skates:conditional= intermittent= internet_access= internet_access:fee= int_network= irrigated= is_capital= is_in:iso_3166_2= is_in:municipality_code= key= lane= LAYER= lottery= male= military= monastery:type= name_1= name:ab= name:ace= name:ak= name:als= name_alt= name:ang= name:ay= name:backward= name:bcl= name:bi= name:bm= name:bpy= name:bug= name:bxr= name:cbk-zam= name:cdo= name:ce= name:ceb= name:ch= name:chy= name:crh= name:csb= name:cu= name:diq= name:dsb= name:dv= name:eml= name:etymology:wikidata= name:ff= name:fiu-vro= name:forward= name:frp= name:frr= name:gag= name:gan= name:gl= name:glk= name:gn= name:ha= name:hak= name:hif= name:hsb= name:ht= name:ie= name:ig= name:ik= name:ilo= name:io= name:iu= name:jbo= name:jv= name:kaa= name:kg= name:ki= name:krc= name:ks= name:ksh= name:kw= name:lad= name:left= name:lg= name:li= name:lij= name:lmo= name:lo= name:ltg= name:mdf= name:min= name:mrj= name:mwl= name:myv= name:na= name:nah= name:nap= name:nb= name:nds= name:new= name:nov= name:nrm= name:nv= name:oc= name:pa= name:pag= name:pam= name:pap= name:pcd= name:pdc= name:pih= name:pms= name:pnt= name:pt-br= name:qu= name:right= name:rmy= name:roa-tara= name:rw= name:sc= name:sco= name:sg= name:sh= name:si= name:simple= name:sm= name:sn= name:sr-Latn= name:srn= name:ss= name:st= name:stq= name:su= name:ti= name:tk= name:tpi= name:ts= name:ty= name:tzl= name:ug= name:uz= name:vec= name:vep= name:vls= name:vo= name:wa= name:war= name:wo= name:wuu= name:xal= name:za= name:zea= name:zh-classical= name:zh-min-nan= naptan:StopAreaCode= naptan:StopAreaType= naptan:verified= networks= note:website= official_name:be= official_name:en= official_name:eo= official_name:fr= official_name:gd= official_name:id= official_name:lb= official_name:lt= official_name:pl= official_name:sk= official_name:sr= official_name:sv= official_name:vi= old_name_1= old_name:ku= old_name:vi= outdoor_seating= overtaking= owner= parking:condition= parking:lane= parking:lane:side= place_name= pna= Proteccion Civil Escorial= protection_title:category= protect_title= rank= rcn= rcn_ref= rednap:altitudortometrica= rednap:codigoine= rednap:ficha= rednap:grupo= rednap:latitud= rednap:longitud= rednap:nodo= rednap:numero= rednap:posicion= rednap:tipo= ref:bic= ref:left= ref:right= role= route_1= route_ref_1= ruins= seats= second_hand= service_times= source:alt_name= source:date:description= source:date:email= source:highway= source:image= source:name:en= source:noref= source:wfs= square= stairs= stop= time_off= time_on= to:es= tracks= transit:lanes= Travesía de la Toribia= unisex= wiki:symbol= works=" madrid-highways-prefiltrado2.osm > madrid-highways-prefiltrado3.osm

# wikipedia= wikidata=

echo "filter 4"
# Filtrar Aceras y áreas peatonales
#osmfilter --drop-node-way-tags="footway=sideway" madrid-highways-prefiltrado3.osm > madrid-highways-prefiltrado31.osm
osmfilter --keep="highway= exit_to= oneway= lanes= ref= bicycle= bridge= tunnel= cycleway= crossing= mountain_pass=" --drop="area=yes" madrid-highways-prefiltrado3.osm > madrid-highways-prefiltrado4.osm

echo "filter 5"
# Filtrar URL's
grep -v '"http' madrid-highways-prefiltrado4.osm | grep -v 'http:' | grep -v 'https:' > calles-sin-urls.osm
# Filtrar 6 highway=elevator
grep -v '"elevator"' calles-sin-urls.osm > a ; mv a calles-sin-urls.osm
# Filtrar traffic_signals, usamos del Ayto
grep -v "traffic_signals" calles-sin-urls.osm > a ; mv a calles-sin-urls.osm


#echo "filter 6: Añadir bicycle=no a highway=footway y highway=sidewalk"
#perl -pe 's/<tag k="highway" v="footway"\/>/<tag k="highway" v="footway"\/> <tag k="bicycle" v="no"\/>/g' calles-sin-urls.osm | perl -pe 's/<tag k="highway" v="sidewalk"\/>/<tag k="highway" v="sidewalk"\/> <tag k="bicycle" v="no"\/>/g' | perl -pe 's/<tag k="highway" v="pedestrian"\/>/<tag k="highway" v="pedestrian"\/> <tag k="bicycle" v="no"\/>/g' > a ; mv a calles-sin-urls.osm

echo "Añadir timestamp y version (si no, falla osmosis)"
DIA=`date +%Y-%m-%d`
HORA=`date +%H:%M:%S`
osmconvert --fake-version --timestamp="$DIA"T"$HORA"Z calles-sin-urls.osm -o=calles-sin-urls-timestamp1.osm # Si no, falla por no tener timestamp
#perl -pe 's/id="/timestamp="'$DIA'T'$HORA'Z" id="/g' calles-sin-urls-timestamp1.osm | perl -pe "s/nd ref=\"/nd ref=\"-/g" | perl -pe 's/ref="\-\-/ref="\-/g' > calles-sin-urls-timestamp.osm
perl -pe 's/id="/action="modify" timestamp="'$DIA'T'$HORA'Z" id="/g' calles-sin-urls-timestamp1.osm > calles-sin-urls-timestamp.osm


perl -pe 's/id="/changeset="1" id="/g' calles-sin-urls-timestamp.osm  > calles-con-changeset.osm

echo "convert to osm..."
osmosis --read-xml file="calles-con-changeset.osm" --write-xml file="calles-tmp.osm"

echo "renumber..."
osmium sort "calles-tmp.osm" -o "calles-sorted.osm"
osmium renumber --start-id=0 "calles-sorted.osm" -o "callesmadrid-OSM.osm"

echo "copy to /var/www/html/..."
cp callesmadrid-OSM.osm /var/www/html/

echo "convert to pbf..."
osmosis --read-xml file="callesmadrid-OSM.osm" --write-pbf file="callesmadrid-OSM.pbf"


cd ..
rm current
ln -s $DIR current

# Borrado de los archivos temporales
cd "$DIR"
cp callesmadrid-OSM.osm ..
cp callesmadrid-OSM.pbf ..
rm *osm
mv ../callesmadrid-OS* .

exit 0
########################## HASTA AQUÍ ES SUFICIENTE PARA V. 1 #######################
